// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/network_interface.hpp"



network_interface::network_interface( sc_core::sc_module_name name_ ) :
    sc_core::sc_module( name_ ),
    clk("clk"),
    reset("reset"),
    mode("mode"),
    rx_data_ready("rx_data_ready"),
    rx_data("rx_data"),
    tx_data_ready("tx_data_ready"),
    tx_data("tx_data"),
    tx_data_done("tx_data_done"),
    net_data_available("net_data_available"),
    net_data_sent("net_data_sent"),
    net_data_incoming("net_data_incoming"),
    net_data_outgoing("net_data_outgoing"),
    clkSuphif_2("clkSuphif_2")
{
    rx_data_ready.initialize( false );
    rx_data.initialize( 0UL );
    tx_data_done.initialize( false );
    net_data_available = false;
    net_data_sent = false;
    net_data_incoming = 0UL;
    net_data_outgoing = 0UL;
    clkSuphif_2 = false;

    SC_METHOD( vhdl_process );
    sensitive << clk;

    SC_METHOD( UpdclkSuphif_2 );
    sensitive << clk;
}

network_interface::~network_interface()
{}

void network_interface::vhdl_process()
{
    if (clk.read() != clkSuphif_2.read() && clk.read() == true)
    {
        if (reset.read() == true)
        {
            rx_data = 0UL;
            rx_data_ready = false;
            tx_data_done = false;
            net_data_outgoing = 0UL;
        }
        else
        {
            if (mode.read() == false)
            {
                if (net_data_available.read() == true)
                {
                    rx_data = net_data_incoming.read();
                    if (rx_data_ready.read() == false)
                    {
                        rx_data_ready = true;
                    }
                }
                else
                {
                    rx_data = 0UL;
                    rx_data_ready = false;
                }
            }
            else
            {
                if (tx_data_ready.read() == true)
                {
                    net_data_outgoing = tx_data.read();
                    tx_data_done = net_data_sent.read();
                }
                else
                {
                    net_data_outgoing = 0UL;
                    tx_data_done = false;
                }
            }
        }
    }
}

void network_interface::UpdclkSuphif_2()
{
    clkSuphif_2 = clk.read();
}



